///////////////////////////////////////////////////////////////////////////////////
//No part of this file can be copied or released without the consent of 
//Avalanche Technology
//										
///////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////
//										
//	Avalanche Technology Inc., Proprietary and Confidential	   *
//										
// 	Release:  3.0    Date 6/7/2023  	
//							
//////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////
//  PART DESCRIPTION:
//
//  Technology: 22nm pMTJ STT-MRAM
//  Part:       AS3001308/AS3004308/AS3008308/AS3016308/AS3032308
//
//  Description: 1/4/8/16/32 MEGABIT PARALLEL PERSISTENT SRAM MEMORY
//
////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////
//  FILE CONTENTS : STIMULUS for Testbench
//
////////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////////
// MODULE DECLARATION                                                             //
////////////////////////////////////////////////////////////////////////////////////

`timescale 1ns/1ps

module stimulus (
	output reg En,
	output reg Wn,

	output reg [21:0] ADDR,
	inout [7:0] DQ,
 	output reg Gn
	);

reg [7:0] DQ_reg;
reg out_en;

`include "./task.v"

assign DQ = out_en ? DQ_reg : 32'hz;

initial begin
  En = 1'b1;
  Wn = 1'b1;
  Gn = 1'b1;
  ADDR = 0;
  DQ_reg = 0;
  out_en = 0;
end

initial begin
    #100;

    /*$display("Write Read Sequence");
    WriteReadCheck();*/

    $display("==== [TEST] Write ====");
    WriteRelTime(22'h100, 8'h01, 8'd0,8'd5,8'd10,8'd15,8'd0,8'd15);
    WriteRelTime(22'h200, 8'h02, 8'd0,8'd5,8'd10,8'd15,8'd0,8'd15);
    WriteRelTime(22'h300, 8'h03, 8'd0,8'd0,8'd13,8'd15,8'd0,8'd17);
    ReadRelTime(22'h100,8'h01, 8'd0,8'd20,8'd25,8'd0,8'd1);
    #10;
    WriteRelTime(22'h400, 8'h04, 8'd0,8'd0,8'd13,8'd15,8'd0,8'd17);
    #50;
    WriteRelTime(22'h500, 8'h05, 8'd0,8'd0,8'd13,8'd15,8'd0,8'd17);
    ReadRelTime(22'h200,8'h02, 8'd0,8'd20,8'd25,8'd0,8'd1);
    ReadRelTime(22'h500,8'h05, 8'd0,8'd20,8'd25,8'd0,8'd1);
    ReadRelTime(22'h400,8'h04, 8'd0,8'd20,8'd25,8'd0,8'd1);
    ReadRelTime(22'h300,8'h03, 8'd0,8'd20,8'd25,8'd0,8'd1);
    #50;
    ReadRelTimeEnTrig(22'h100,8'h01, 8'd0,8'd0,8'd45,8'd0,8'd1);
    #100;

    $finish();
end

endmodule
